<?php
/*
 *	$Id: sslclient.php,v 1.2 2008-04-25 09:40:39 mateusz Exp $
 *
 *	SSL client sample.
 *
 *	Service: SOAP endpoint
 *	Payload: rpc/encoded
 *	Transport: https
 *	Authentication: none
 */
require_once('lib/nusoap.php');
//funckja do pomiaru czasu wykonania
function microtime_float()
{
    list($usec, $sec) = explode(" ", microtime());
    return ((float)$usec + (float)$sec);
}

set_time_limit (300);
//w wersji produkcyjnej debug powinien zostać wylaczony
//nusoap_base::setGlobalDebugLevel(0);

$client = new nusoap_client(
	'https://www.enewsletter.pl/api/server.php?wsdl',	//mixed  $endpoint
	'wsdl',	//bool  $wsdl=false
	false,	//string $proxyhost = false
	false,	//string $proxyport = false
	false, //string $proxyusername = false
	false,	//string $proxypassword = false
	120,	//integer $timeout
	300,	//integer $response_timeout = 30
	false	//int $portName
	);
//kodowanie UTF-8 do i z SARE
$client->soap_defencoding="UTF-8";
$client->decode_utf8 = false;
//$client->setDebugLevel(0);
//ustawienie certyfikatu osobistego
$certRequest['sslcertfile']="./Test.crt";
$certRequest['sslkeyfile']="./Test.key";
$client->setCredentials("","","certificate",$certRequest);

$err = $client->getError();
if ($err) {
	echo '<h2>Constructor error</h2><pre>' . $err . '</pre>';
}
//wersja z proxy - bezposrednie wywolanie metod
$proxy = $client->getProxy();
//stworzenie 1000 adresow z losowymi danymi
for($i=0;$i<1000;$i++){
	//adres email
	$obj[$i]['email']="soap".$i."@mx.enewsletter.pl";
	$nr=rand(1,9);
	//losowa cecha
	$obj[$i]['prop'.$nr]=$nr;
	//dopisz do grupy 35
	$obj[$i]['groups']=array(35);
	//ze statusem 8
	$obj[$i]['status']=8;
}

$time_start = microtime_float();
/*ImportAddresses(
	$obiekt, --lista adresow
	onDuplicate, --co zrobic z danymi gdy adres istnieje 
		"update" --uaktualnij ustawione dane (reszta danych bez zmian)
		"replace" --nadpisz wszystkie dane (kasuj historie)
		"skip" --opuść
	onDuplicateStatusChange --czy nadpisać status gdy adres istnieje
*/
$result = $proxy->ImportAddresses($obj, "replace", true);
$time_end = microtime_float();
if ($proxy->fault) {
	echo '<h2>Fault</h2><pre>'; print_r($result); echo '</pre>';
} else {
	$err = $proxy->getError();
	if ($err) {
		echo '<h2>Error</h2><pre>' . $err . '</pre>';
	} else {
		echo '<h2>Result</h2><pre>'; print_r($result); echo '</pre>';
	}
}
echo '<h2>Request</h2><pre>' . htmlspecialchars($proxy->request, ENT_QUOTES) . '</pre>';
echo '<h2>Response</h2><pre>' . htmlspecialchars($proxy->response, ENT_QUOTES) . '</pre>';
echo '<h2>Debug</h2><pre>' . htmlspecialchars($proxy->debug_str, ENT_QUOTES) . '</pre>';

$time = $time_end - $time_start;
echo '<h2>Time</h2><pre>' . $time . '</pre>';
?>




